#include <iostream>

using namespace std;

int main()
{
    int n; cin >> n;

    for(int i = 0; i < n - 1; i++)
    {
        int x, y; cin >> x >> y;
    }

    int rez = 1;
    int najvise = 0;

    for(int i = 0; i < n; i++)
    {
        int zlato; cin >> zlato;
        if(zlato > najvise)
        {
            najvise = zlato;
            rez = i + 1;
        }
    }

    int q; cin >> q;

    for(int i = 0; i < q; i++)
    {
        int z, b; cin >> z >> b;
    }

    for(int i = 0; i < q + 1; i++)
    {
        cout << rez << endl;
    }

    return 0;
}